#include <common.h>
#include <asm/io.h>
#include <lcd.h>
#include <nand.h>

int lcd_line_length;
int lcd_color_fg;
int lcd_color_bg;

void *lcd_base;                         /* Start of framebuffer memory  */
void *lcd_console_address;              /* Start of console buffer      */

short console_col;
short console_row;

void lcd_setcolreg(ushort regno, ushort red, ushort green, ushort blue)
{
}

void lcd_ctrl_init(void *lcdbase)
{
	nand_info_t *nand;
	char *s;

	nand = &nand_info[nand_curr_device];

	if ((s = getenv("splashimage")) != NULL) {
		ulong addr, off, size;

		addr = simple_strtoul(s, NULL, 16);
		off  = 0x100000;
		size = 0x120000;
		nand_read(nand, off, &size, (u_char *)addr);
	}

//	*((uint *) 0x48310034) = 0xfefffedf;//GPIO_OE
//	*((uint *) 0x48310094) = 0x01000120;//GPIO_SETDATAOUT
	*((uint *) 0x48004D44) = 0x0001b00c;//CM_CLKSEL2_PLL
	*((uint *) 0x48004E40) = 0x00001006;//CM_CLKSEL_DSS
	*((uint *) 0x48004D00) = 0x00370037;//CM_CLKEN_PLL
	*((uint *) 0x48050C00) = 0x00000002;
	*((uint *) 0x48050C04) = 0x0000001B;//VENC_STATUS
	*((uint *) 0x48050C08) = 0x00000040;//VENC_F_CONTROL
	*((uint *) 0x48050C0C) = 0x00000000;
	*((uint *) 0x48050C10) = 0x00000000;//VENC_VIDOUT_CTRL
	*((uint *) 0x48050C14) = 0x00008000;//VENC_SYNC_CTRL
	*((uint *) 0x48050C18) = 0x00000000;
	*((uint *) 0x48050C1C) = 0x00008359;//VENC_LLEN
	*((uint *) 0x48050C20) = 0x0000020C;//VENC_FLENS
	*((uint *) 0x48050C24) = 0x00000000;//VENC_HFLTR_CTRL
	*((uint *) 0x48050C28) = 0x043F2631;//VENC_CC_CARR_WSS_CARR
	*((uint *) 0x48050C2C) = 0x00000024;//VENC_C_PHASE
	*((uint *) 0x48050C30) = 0x00000130;//VENC_GAIN_U
	*((uint *) 0x48050C34) = 0x00000198;//VENC_GAIN_V
	*((uint *) 0x48050C38) = 0x000001C0;//VENC_GAIN_Y
	*((uint *) 0x48050C3C) = 0x0000006A;//VENC_BLACK_LEVEL
	*((uint *) 0x48050C40) = 0x0000005C;//VENC_BLANK_LEVEL
	*((uint *) 0x48050C44) = 0x00000000;//VENC_X_COLOR
	*((uint *) 0x48050C48) = 0x00000001;//VENC_M_CONTROL
	*((uint *) 0x48050C4C) = 0x0000003F;//VENC_BSTAMP_WSS_DATA
	*((uint *) 0x48050C50) = 0x21F07C1F;//VENC_S_CARR
	*((uint *) 0x48050C54) = 0x00000000;//VENC_LINE21
	*((uint *) 0x48050C58) = 0x00000015;//VENC_LN_SEL
	*((uint *) 0x48050C5C) = 0x00001400;//VENC_WC_CTL
	*((uint *) 0x48050C60) = 0x00000000;//VENC_HTRIGGER_VTRIGGER
	*((uint *) 0x48050C64) = 0x069300F4;//VENC_SAVID_EAVID
	*((uint *) 0x48050C68) = 0x0016020C;//VENC_FLEN_FAL
	*((uint *) 0x48050C6C) = 0x00060107;//VENC_LAL_PHASE_RESET
	*((uint *) 0x48050C70) = 0x008D034E;//VENC_HS_INT_START_STOP_X
	*((uint *) 0x48050C74) = 0x000F0359;//VENC_HS_EXT_START_STOP_X
	*((uint *) 0x48050C78) = 0x01A00000;//VENC_VS_INT_START_X	
	*((uint *) 0x48050C7C) = 0x020501A0;//VENC_VS_INT_STOP_X_VS_INT_START_Y
	*((uint *) 0x48050C80) = 0x01AC0024;//VENC_VS_INT_STOP_Y_VS_EXT_START_X
	*((uint *) 0x48050C84) = 0x020D01AC;//VENC_VS_EXT_STOP_X_VS_EXT_START_Y
	*((uint *) 0x48050C88) = 0x00000006;//VENC_VS_EXT_STOP_Y
	*((uint *) 0x48050C8C) = 0x00000000;
	*((uint *) 0x48050C90) = 0x03480079;//VENC_AVID_START_STOP_X
	*((uint *) 0x48050C94) = 0x02040024;//VENC_AVID_START_STOP_Y
	*((uint *) 0x48050C98) = 0x00000000;
	*((uint *) 0x48050C9C) = 0x00000000;
	*((uint *) 0x48050CA0) = 0x0001008A;//VENC_FID_INT_START_X_FID_INT_START_Y
	*((uint *) 0x48050CA4) = 0x01AC0106;//VENC_FID_INT_OFFSET_Y_FID_EXT_START_X
	*((uint *) 0x48050CA8) = 0x01060006;//VENC_FID_EXT_START_Y_FID_EXT_OFFSET_Y
	*((uint *) 0x48050CAC) = 0x00000000;
	*((uint *) 0x48050CB0) = 0x00140001;//VENC_TVDETGP_INT_START_STOP_X
	*((uint *) 0x48050CB4) = 0x00010001;//VENC_TVDETGP_INT_START_STOP_Y
	*((uint *) 0x48050CB8) = 0x00FF0000;//VENC_GEN_CTRL
	*((uint *) 0x48050CBC) = 0x00000000;
	*((uint *) 0x48050CC0) = 0x00000000;
	*((uint *) 0x48050CC4) = 0x0000000D/*0x0000000A*/;//VENC_OUTPUT_CONTROL(s-video/tv)
	*((uint *) 0x48050CC8) = 0x00000000;//VENC_OUTPUT_TEST
	*((uint *) 0x48050010) = 0x00000001;//DSS_SYSCONFIG
	*((uint *) 0x48050040) = 0x00000078/*0x00000038*/;//DSS_CONTROL(s-video/tv)
	*((uint *) 0x48050044) = 0x00000000;//DSS_SDI_CONTROL
	*((uint *) 0x48050048) = 0x00000000;//DSS_PLL_CONTROL
	*((uint *) 0x48050050) = 0x00000000;
	*((uint *) 0x48050058) = 0x00000000;
	*((uint *) 0x48050410) = 0x00002015;//DISPC_SYSCONFIG
	*((uint *) 0x48050414) = 0x00000001;//DISPC_SYSSTATUS
	*((uint *) 0x48050444) = 0x00000004;//DISPC_CONFIG
	*((uint *) 0x4805044c) = 0xFFFFFFFF;//DISPC_DEFAULT_COLORm
	*((uint *) 0x48050450) = 0x00000000;//DISPC_DEFAULT_COLORm
	*((uint *) 0x48050454) = 0x00000000;//DISPC_TRANS_COLORm
	*((uint *) 0x48050458) = 0x00000000;//DISPC_TRANS_COLORm
	*((uint *) 0x48050464) = (panel_info.hbp - 1) << 20 |
				 (panel_info.hfp - 1) << 8 |
				 (panel_info.hsw - 1);//DISPC_TIMING_H
	*((uint *) 0x48050468) = (panel_info.vbp - 0) << 20 |
				 (panel_info.vfp - 0) << 8 |
				 (panel_info.vsw - 1);//DISPC_TIMING_V
	*((uint *) 0x4805046c) = (panel_info.config & OMAP_LCDC_SIGNAL_MASK) << 12;//DISPC_POL_FREQ
	*((uint *) 0x48050470) = (0x1 << 16) | (144000000 / panel_info.vl_clk);//DISPC_DIVISOR
	*((uint *) 0x48050478) = 0x00ef027f;//DISPC_SIZE_DIG
	*((uint *) 0x4805047c) = (panel_info.vl_row - 1) << 16 |
				 (panel_info.vl_col - 1);//DISPC_SIZE_LCD
	*((uint *) 0x48050480) = (u_long)lcdbase;//DISPC_GFX_BAj
	*((uint *) 0x48050484) = (u_long)lcdbase;//DISPC_GFX_BAj
	*((uint *) 0x48050488) = 0x00000000;//DISPC_GFX_POSITION
	*((uint *) 0x4805048c) = (panel_info.vl_row - 1) << 16 |
                                 (panel_info.vl_col - 1);//DISPC_GFX_SIZE
	*((uint *) 0x480504a0) = 0x0000008d/*0x00000087*/;//DISPC_GFX_ATTRIBUTES(rgb/bmp)
	*((uint *) 0x480504a4) = 0x03fc03bc;//DISPC_GFX_FIFO_THRESHOLD
	*((uint *) 0x480504a8) = 0x00000400;//DISPC_GFX_FIFO_SIZE_STATUS
	*((uint *) 0x480504ac) = 0x00000001;//DISPC_GFX_ROW_INC
	*((uint *) 0x480504b0) = 0x00000001;//DISPC_GFX_PIXEL_INC
	*((uint *) 0x480504b4) = 0x00000000;//DISPC_GFX_WINDOW_SKIP
	*((uint *) 0x480504b8) = 0x807ff000;//DISPC_GFX_TABLE_BA
	udelay(1000);
#if 0
	*((uint *) 0x48050440) = 0x0001836b;
	udelay(1000);
	*((uint *) 0x48050440) = 0x0001836b;
	udelay(1000);
	*((uint *) 0x48050440) = 0x0001836b;
	udelay(1000);
#endif
}

ulong calc_fbsize(void)
{
        return ((panel_info.vl_col * panel_info.vl_row *
                NBITS(panel_info.vl_bpix)) / 8) + PAGE_SIZE;
}

void lcd_enable(void)
{
        *((uint *) 0x48050440) = 0x0001836b;
        udelay(1000);
        *((uint *) 0x48050440) = 0x0001836b;
        udelay(1000);
        *((uint *) 0x48050440) = 0x0001836b;
        udelay(1000);
}

void lcd_disable(void)
{

}

void lcd_panel_disable(void)
{
	unsigned char byte;

        byte = 0x33;
        i2c_write(0x4A, 0xEE, 1, &byte, 1);//LEDA enable/LCD disable	
}
